/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropConf$Battle
 *  fire.pb.PropConf$Specialquest
 *  fire.pb.battle.HideBattle
 *  fire.pb.buff.BuffRoleImpl
 *  fire.pb.circletask.CircleTask
 *  fire.pb.circletask.EnterAnYePatrolBattle
 *  fire.pb.circletask.EnterCircTaskPatrolBattle
 *  fire.pb.circletask.anye.RoleAnYeTask
 *  fire.pb.main.ConfigManager
 *  fire.pb.mission.EnterScenarioPatrolBattle
 *  fire.pb.mission.MissionConfig
 *  fire.pb.mission.MissionManager
 *  fire.pb.mission.RoleMission
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.FireProp
 *  fire.pb.util.Misc
 *  xtable.Properties
 */
package fire.pb.map;

import fire.pb.PropConf;
import fire.pb.battle.HideBattle;
import fire.pb.buff.BuffRoleImpl;
import fire.pb.circletask.CircleTask;
import fire.pb.circletask.EnterAnYePatrolBattle;
import fire.pb.circletask.EnterCircTaskPatrolBattle;
import fire.pb.circletask.anye.RoleAnYeTask;
import fire.pb.main.ConfigManager;
import fire.pb.map.Role;
import fire.pb.map.SMineArea;
import fire.pb.map.SceneManager;
import fire.pb.mission.EnterScenarioPatrolBattle;
import fire.pb.mission.MissionConfig;
import fire.pb.mission.MissionManager;
import fire.pb.mission.RoleMission;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.FireProp;
import fire.pb.util.Misc;
import xtable.Properties;

public class SceneBattle {
    public static final int MIN_BATTLE_INTERVAL_NOTEAM = 20000;
    public static final int MIN_BATTLE_INTERVAL_TEAM = 30000;

    private static boolean checkBattleUnit(Role role, long curTick) {
        Team team = TeamManager.selectTeamByRoleId((long)role.getRoleID());
        if (team == null || team.isAbsentMember(role.getRoleID())) {
            if (curTick - role.getLastHideBattleTick() < 20000L) {
                return false;
            }
        } else {
            if (team.isNormalMember(role.getRoleID())) {
                return false;
            }
            if (team.isTeamLeader(role.getRoleID()) && curTick - role.getLastHideBattleTick() < 30000L) {
                return false;
            }
        }
        return true;
    }

    public static void process(Role role, int newRoadLen, long curTick, int conf) {
        BuffRoleImpl buffRoleImpl = new BuffRoleImpl(role.getRoleID(), true);
        if (SceneBattle.checkSpecialPatrol(role, newRoadLen)) {
            return;
        }
        if (conf > 0) {
            boolean isScenarioMap = RoleMission.isScenarioIgnoreMap((long)role.getRoleID(), (int)role.getMapId());
            if (isScenarioMap) {
                return;
            }
            if (!SceneBattle.checkBattleUnit(role, curTick)) {
                return;
            }
            int teamSize = TeamManager.getFightTeamMembers((long)role.getRoleID()).size();
            if (teamSize < 5 && role.getHuobanSize() > 0) {
                teamSize += role.getHuobanSize();
            }
            if (teamSize > 5) {
                teamSize = 5;
            }
            if (buffRoleImpl.existBuff(FireProp.getIntValue((String)"battle", (String)"mtgserv.nobattleBuffid"))) {
                return;
            }
            if (buffRoleImpl.existBuff(500008)) {
                int roleLevel;
                SMineArea areaInfo = (SMineArea)ConfigManager.getInstance().getConf(SMineArea.class).get(conf);
                if (null == areaInfo) {
                    return;
                }
                int areaLevel = areaInfo.getLevel();
                if (areaLevel <= (roleLevel = Properties.selectLevel((Long)role.getRoleID()).intValue())) {
                    return;
                }
            }
            role.setRoadLen(role.getRoadLen() + newRoadLen);
            if (SceneBattle.checkEnterHideBattle(role.getRoadLen() / 16 / 3)) {
                new HideBattle(role.getRoleID(), conf, teamSize).launch();
                role.setRoadLen(0);
                role.setLastHideBattleTick(curTick);
            }
        }
    }

    public static boolean checkSpecialPatrol(Role role, int newRoadLen) {
        Team team = TeamManager.selectTeamByRoleId((long)role.getRoleID());
        if (null != team && !team.getAbsentMemberIds().contains(role.getRoleID()) && team.getTeamLeaderId() != role.getRoleID()) {
            return false;
        }
        boolean isCTPatrol = CircleTask.isHavePatrol((long)role.getRoleID()) > 0;
        int isAnYePatrol = RoleAnYeTask.isHavePatrol((long)role.getRoleID());
        int ScenarioPatrolQid = RoleMission.getScenarioPatroling((long)role.getRoleID());
        boolean flag = false;
        if (!isCTPatrol && ScenarioPatrolQid <= 0 && isAnYePatrol < 0) {
            role.setPatrolStep(0);
            flag = false;
        } else {
            EnterAnYePatrolBattle enter;
            if (isAnYePatrol >= 0) {
                if (!RoleAnYeTask.getPatrolMap((long)role.getRoleID()).contains(role.getMapId())) {
                    flag = false;
                } else {
                    role.setPatrolStep(role.getPatrolStep() + newRoadLen);
                    if (role.getPatrolStep() < 60 * PropConf.Specialquest.PATROL_MINSTEP) {
                        flag = false;
                    } else if (role.getPatrolStep() >= 60 * PropConf.Specialquest.PATROL_MAXSTEP) {
                        enter = new EnterAnYePatrolBattle(role.getRoleID(), role.getMapId());
                        enter.enterBattle();
                        role.setPatrolStep(0);
                        flag = true;
                    } else if (Misc.checkRatePercent((int)PropConf.Specialquest.PATROL_BATTL)) {
                        enter = new EnterAnYePatrolBattle(role.getRoleID(), role.getMapId());
                        enter.enterBattle();
                        role.setPatrolStep(0);
                        flag = true;
                    }
                    SceneManager.logger.debug((Object)("暗夜马雷巡逻  玩家当前步数" + role.getPatrolStep() + "newRoadLen" + newRoadLen));
                }
            }
            if (isCTPatrol) {
                if (!CircleTask.getCTPatrolMap((long)role.getRoleID()).contains(role.getMapId())) {
                    flag = false;
                } else {
                    role.setPatrolStep(role.getPatrolStep() + newRoadLen);
                    if (role.getPatrolStep() < 60 * PropConf.Specialquest.PATROL_MINSTEP) {
                        flag = false;
                    } else if (role.getPatrolStep() >= 60 * PropConf.Specialquest.PATROL_MAXSTEP) {
                        enter = new EnterCircTaskPatrolBattle(role.getRoleID(), role.getMapId());
                        enter.enterBattle();
                        role.setPatrolStep(0);
                        flag = true;
                    } else if (Misc.checkRatePercent((int)PropConf.Specialquest.PATROL_BATTL)) {
                        enter = new EnterCircTaskPatrolBattle(role.getRoleID(), role.getMapId());
                        enter.enterBattle();
                        role.setPatrolStep(0);
                        flag = true;
                    }
                    SceneManager.logger.debug((Object)("循环任务师门巡逻  玩家当前步数" + role.getPatrolStep() + "newRoadLen" + newRoadLen));
                }
            }
            if (ScenarioPatrolQid > 0) {
                MissionConfig conf = MissionManager.getInstance().getMissionConfig(ScenarioPatrolQid);
                if (conf == null) {
                    flag = false;
                } else if (role.getMapId() != conf.exeIndo.mapID) {
                    flag = false;
                } else {
                    role.setPatrolStep(role.getPatrolStep() + newRoadLen);
                    SceneManager.logger.debug((Object)("剧情任务巡逻护送  玩家当前步数:" + role.getPatrolStep() + ",newRoadLen:" + newRoadLen));
                    if (role.getPatrolStep() < 60 * PropConf.Specialquest.PATROL_MINSTEP) {
                        flag = false;
                    } else if (role.getPatrolStep() >= 60 * PropConf.Specialquest.PATROL_MAXSTEP) {
                        EnterScenarioPatrolBattle enter2 = new EnterScenarioPatrolBattle(role.getRoleID());
                        enter2.enterBattle();
                        role.setPatrolStep(0);
                        flag = true;
                    } else if (Misc.checkRatePercent((int)PropConf.Specialquest.PATROL_BATTL)) {
                        EnterScenarioPatrolBattle enter3 = new EnterScenarioPatrolBattle(role.getRoleID());
                        enter3.enterBattle();
                        role.setPatrolStep(0);
                        flag = true;
                    }
                }
            }
        }
        return flag;
    }

    public static boolean checkEnterHideBattle(int roadLen) {
        if (roadLen < PropConf.Battle.STEPLEN_NOBATTLE) {
            return false;
        }
        if (roadLen >= PropConf.Battle.STEPLEN_BATTLE) {
            return true;
        }
        return Misc.checkRate((int)10000, (int)(400 + (roadLen - 5) * (30 + (roadLen - 5) / 5 * 10)));
    }
}

